PRINT N'Modificando [dbo].[GetNLU]...';


GO
--exec [GetNLU] NULL,'test2'
ALTER PROCEDURE [dbo].[GetNLU] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[Name]						    'name',
		[Culture]						'culture',
		[Description]					'description',
		[AppId]							'appId',
		[SubscriptionKey]				'subscriptionKey',
		[LastTrainedDate]				'lastTrainedDateTime',
		[LastPublishedDate]				'lastPublishedDateTime',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [NLU] (NOLOCK)
	WHERE [VCC] = CASE WHEN ISNULL(@VCC, '') = '' THEN [VCC] ELSE @VCC END 
	AND [Name] = @Name
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetRolePermissionsGroups]...';


GO
ALTER PROCEDURE [dbo].[GetRolePermissionsGroups] (
	@VCC Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON 

	SELECT
		[Category]						    'category',
		[GroupId] 							'groupId',
		[Type]								'type'
	FROM [RolePermissionsGroup] (NOLOCK)
	WHERE [VCC] = @VCC
	AND (
		[Type] IN ((SELECT  [Product] FROM [VCCLicense] (NOLOCK) WHERE VCC =@VCC))
		OR 
		[Type] = 'SHARED'
	)
	GROUP BY [GroupId],[Category],[Type]
	ORDER BY [GroupId] ASC
	
	SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';